Commit e60e7f5bf0d3d27834b9712529836b42207853c8

Stefan Sperling 2019-02-10T13:03:27

properly deal with "$?" in cmdline tests; fixes spurious test "ok"

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
247
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
267
268
269
270
271
272
273
274
275
276
277
278
279
280
281
282
283
284
285
286
287
288
289
290
291
292
293
294
295
296
297
298
299
300
301
302
303
304
305
306
307
308
309
310
311
312
313
314
315
316
317
318
319
320
321
322
323
324
325
326
327
328
329
330
331
332
333
334
335
336
337
338
339
340
341
342
343
344
345
346
347
348
349
350
351
352
353
354
355
356
357
358
359
360
361
362
363
364
365
366
367
368
369
370
371
372
373
374
375
376
377
378
379
380
381
382
383
384
385
386
387
388
389
390
391
392
393
394
395
396
397
398
399
400
401
402
403
404
405
406
407
408
409
410
411
412
413
414
415
416
417
418
419
420
421
422
423
424
425
426
427
428
429
430
431
432
433
434
435
436
437
438
439
440
441
442
443
444
445
446
447
448
449
450
451
452
453
454
455
456
457
458
459
460
461
462
463
464
465
466
467
468
469
470
471
472
473
474
475
476
477
478
479
480
481
482
483
484
485
486
487
488
489
490
491
492
493
494
495
496
497
498
499
500
501
502
503
504
505
506
507
508
509
510
511
512
513
514
515
516
517
518
519
520
521
522
523
524
525
526
527
528
529
530
531
532
533
534
535
536
537
538
539
540
541
542
543
544
545
546
547
548
549
550
551
552
553
554
555
556
557
558
559
560
561
562
563
564
565
566
567
diff --git a/regress/cmdline/checkout.sh b/regress/cmdline/checkout.sh
index a8b9cef..3123aa9 100755
--- a/regress/cmdline/checkout.sh
+++ b/regress/cmdline/checkout.sh
@@ -26,15 +26,17 @@ function test_checkout_basic {
 	echo "Now shut up and hack" >> $testroot/stdout.expected
 
 	got checkout $testroot/repo $testroot/wt > $testroot/stdout
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
diff --git a/regress/cmdline/status.sh b/regress/cmdline/status.sh
index 26ddd6d..024aa63 100755
--- a/regress/cmdline/status.sh
+++ b/regress/cmdline/status.sh
@@ -20,8 +20,9 @@ function test_status_basic {
 	local testroot=`test_init status_basic`
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -37,13 +38,11 @@ function test_status_basic {
 	(cd $testroot/wt && got status > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
-		return 1
 	fi
-
-	test_done "$testroot" "0"
+	test_done "$testroot" "$ret"
 }
 
 function test_status_subdir_no_mods {
@@ -58,8 +57,9 @@ function test_status_subdir_no_mods {
 	git_commit $testroot/repo -m "add subdir with files"
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -72,13 +72,11 @@ function test_status_subdir_no_mods {
 	(cd $testroot/wt && got status > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
-		return 1
 	fi
-
-	test_done "$testroot" "0"
+	test_done "$testroot" "$ret"
 }
 
 function test_status_subdir_no_mods2 {
@@ -99,8 +97,9 @@ function test_status_subdir_no_mods2 {
 	git_commit $testroot/repo -m "add subdir with files"
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -117,21 +116,20 @@ function test_status_subdir_no_mods2 {
 	(cd $testroot/wt && got status > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
-		return 1
 	fi
-
-	test_done "$testroot" "0"
+	test_done "$testroot" "$ret"
 }
 
 function test_status_obstructed {
 	local testroot=`test_init status_obstructed`
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -143,13 +141,11 @@ function test_status_obstructed {
 	(cd $testroot/wt && got status > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
+	ret="$?"
 	if [ "$?" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
-		return 1
 	fi
-
-	test_done "$testroot" "0"
+	test_done "$testroot" "$ret"
 }
 
 function test_status_shows_local_mods_after_update {
@@ -202,11 +198,8 @@ function test_status_shows_local_mods_after_update {
 	ret="$?"
 	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$ret"
-		return 1
 	fi
-
-	test_done "$testroot" "0"
+	test_done "$testroot" "$ret"
 }
 
 run_test test_status_basic
diff --git a/regress/cmdline/update.sh b/regress/cmdline/update.sh
index 8e67c9a..e7ae6c1 100755
--- a/regress/cmdline/update.sh
+++ b/regress/cmdline/update.sh
@@ -20,8 +20,9 @@ function test_update_basic {
 	local testroot=`test_init update_basic`
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -36,9 +37,10 @@ function test_update_basic {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -57,8 +59,9 @@ function test_update_adds_file {
 	local testroot=`test_init update_adds_file`
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -74,9 +77,10 @@ function test_update_adds_file {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -95,8 +99,9 @@ function test_update_deletes_file {
 	local testroot=`test_init update_deletes_file`
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -111,9 +116,10 @@ function test_update_deletes_file {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -130,8 +136,9 @@ function test_update_deletes_dir {
 	local testroot=`test_init update_deletes_dir`
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -146,9 +153,10 @@ function test_update_deletes_dir {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -172,8 +180,9 @@ function test_update_deletes_dir_with_path_prefix {
 
 	# check out the epsilon/ sub-tree
 	got checkout -p epsilon $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -184,9 +193,10 @@ function test_update_deletes_dir_with_path_prefix {
 	(cd $testroot/wt && got update -c $first_rev > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -212,8 +222,9 @@ function test_update_deletes_dir_recursively {
 
 	# check out the epsilon/ sub-tree
 	got checkout -p epsilon $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -225,9 +236,10 @@ function test_update_deletes_dir_recursively {
 	(cd $testroot/wt && got update -c $first_rev > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
+	ret="$?"
 	if [ "$?" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -244,8 +256,9 @@ function test_update_sibling_dirs_with_common_prefix {
 	local testroot=`test_init update_sibling_dirs_with_common_prefix`
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -265,9 +278,10 @@ function test_update_sibling_dirs_with_common_prefix {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -286,28 +300,28 @@ function test_update_sibling_dirs_with_common_prefix {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
-		return 1
 	fi
-
-	test_done "$testroot" "0"
+	test_done "$testroot" "$ret"
 }
 
 function test_update_dir_with_dot_sibling {
 	local testroot=`test_init update_dir_with_dot_sibling`
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$ret"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -326,9 +340,10 @@ function test_update_dir_with_dot_sibling {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -343,20 +358,19 @@ function test_update_dir_with_dot_sibling {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
-		return 1
 	fi
-
-	test_done "$testroot" "0"
+	test_done "$testroot" "$ret"
 }
 
 function test_update_moves_files_upwards {
@@ -370,8 +384,9 @@ function test_update_moves_files_upwards {
 	git_commit $testroot/repo -m "adding a sub-directory beneath epsilon"
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -390,9 +405,10 @@ function test_update_moves_files_upwards {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -422,8 +438,9 @@ function test_update_moves_files_to_new_dir {
 	git_commit $testroot/repo -m "adding a sub-directory beneath epsilon"
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -443,9 +460,10 @@ function test_update_moves_files_to_new_dir {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -474,8 +492,9 @@ function test_update_creates_missing_parent {
 	git_commit $testroot/repo -m "adding initial snake tree"
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -508,13 +527,11 @@ function test_update_creates_missing_parent {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
-		return 1
 	fi
-
-	test_done "$testroot" "0"
+	test_done "$testroot" "$ret"
 }
 
 function test_update_creates_missing_parent_with_subdir {
@@ -527,8 +544,9 @@ function test_update_creates_missing_parent_with_subdir {
 	git_commit $testroot/repo -m "adding initial snake tree"
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -561,9 +579,10 @@ function test_update_creates_missing_parent_with_subdir {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -582,8 +601,9 @@ function test_update_file_in_subsubdir {
 	git_commit $testroot/repo -m "adding initial tree"
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -599,9 +619,10 @@ function test_update_file_in_subsubdir {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -623,8 +644,9 @@ function test_update_merges_file_edits {
 	git_commit $testroot/repo -m "added numbers file"
 
 	got checkout $testroot/repo $testroot/wt > /dev/null
-	if [ "$?" != "0" ]; then
-		test_done "$testroot" "$?"
+	ret="$?"
+	if [ "$ret" != "0" ]; then
+		test_done "$testroot" "$ret"
 		return 1
 	fi
 
@@ -647,9 +669,10 @@ function test_update_merges_file_edits {
 	(cd $testroot/wt && got update > $testroot/stdout)
 
 	cmp $testroot/stdout.expected $testroot/stdout
-	if [ "$?" != "0" ]; then
+	ret="$?"
+	if [ "$ret" != "0" ]; then
 		diff -u $testroot/stdout.expected $testroot/stdout
-		test_done "$testroot" "$?"
+		test_done "$testroot" "$ret"
 		return 1
 	fi